com.jnape.palatable.lambda.functions.builtin.fn4

## Class IfThenElse<A,B>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn4.IfThenElse<A,B>

- All Implemented Interfaces:
    Fn1<Fn1<? super A,? extends Boolean>,Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>>, Fn2<Fn1<? super A,? extends Boolean>,Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>, Fn3<Fn1<? super A,? extends Boolean>,Fn1<? super A,? extends B>,Fn1<? super A,? extends B>,Fn1<A,B>>, Fn4<Fn1<? super A,? extends Boolean>,Fn1<? super A,? extends B>,Fn1<? super A,? extends B>,A,B>, Applicative<Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, Cartesian<Fn1<? super A,? extends Boolean>,Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<?,?>>, Cocartesian<Fn1<? super A,? extends Boolean>,Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<?,?>>, Contravariant<Fn1<? super A,? extends Boolean>,Profunctor<?,Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<?,?>>>, Functor<Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, Profunctor<Fn1<? super A,? extends Boolean>,Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<?,?>>, Monad<Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, MonadReader<Fn1<? super A,? extends Boolean>,Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, MonadRec<Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, MonadWriter<Fn1<? super A,? extends Boolean>,Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends B>,Fn1<A,B>>>,Fn1<Fn1<? super A,? extends Boolean>,?>>

      public final class IfThenElse<A,B>
      extends Object
      implements Fn4<Fn1<? super A,? extends Boolean>,Fn1<? super A,? extends B>,Fn1<? super A,? extends B>,A,B>

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `B` | `checkedApply(Fn1<? super A,? extends Boolean> predicate, Fn1<? super A,? extends B> thenCase, Fn1<? super A,? extends B> elseCase, A a)`
    `static <A,B> IfThenElse<A,B>` | `ifThenElse()`
    `static <A,B> Fn3<Fn1<? super A,? extends B>,Fn1<? super A,? extends B>,A,B>` | `ifThenElse(Fn1<? super A,? extends Boolean> predicate)`
    `static <A,B> Fn2<Fn1<? super A,? extends B>,A,B>` | `ifThenElse(Fn1<? super A,? extends Boolean> predicate, Fn1<? super A,? extends B> thenCase)`
    `static <A,B> Fn1<A,B>` | `ifThenElse(Fn1<? super A,? extends Boolean> predicate, Fn1<? super A,? extends B> thenCase, Fn1<? super A,? extends B> elseCase)`
    `static <A,B> B` | `ifThenElse(Fn1<? super A,? extends Boolean> predicate, Fn1<? super A,? extends B> thenCase, Fn1<? super A,? extends B> elseCase, A a)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn4

      `apply, apply, apply, apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn4, fn4, fn4, fn4, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `checkedApply, fn3, fn3, fn3`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `checkedApply, curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public B checkedApply(Fn1<? super A,? extends Boolean> predicate,
                                Fn1<? super A,? extends B> thenCase,
                                Fn1<? super A,? extends B> elseCase,
                                A a)

      Specified by:
        `checkedApply` in interface `Fn4<Fn1<? super A,? extends Boolean>,Fn1<? super A,? extends B>,Fn1<? super A,? extends B>,A,B>`

    - #### ifThenElse

          public static <A,B> IfThenElse<A,B> ifThenElse()

    - #### ifThenElse

          public static <A,B> Fn3<Fn1<? super A,? extends B>,Fn1<? super A,? extends B>,A,B> ifThenElse(Fn1<? super A,? extends Boolean> predicate)

    - #### ifThenElse

          public static <A,B> Fn2<Fn1<? super A,? extends B>,A,B> ifThenElse(Fn1<? super A,? extends Boolean> predicate,
                                                                             Fn1<? super A,? extends B> thenCase)

    - #### ifThenElse

          public static <A,B> Fn1<A,B> ifThenElse(Fn1<? super A,? extends Boolean> predicate,
                                                  Fn1<? super A,? extends B> thenCase,
                                                  Fn1<? super A,? extends B> elseCase)

    - #### ifThenElse

          public static <A,B> B ifThenElse(Fn1<? super A,? extends Boolean> predicate,
                                           Fn1<? super A,? extends B> thenCase,
                                           Fn1<? super A,? extends B> elseCase,
                                           A a)